﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Dienstfahrten.Klassen;
using Microsoft.SharePoint;
using Dienstfahrten.Logging;
using Microsoft.SharePoint.WebControls;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;
using System.Resources;
using System.Reflection;
using Microsoft.SharePoint.Utilities;
using System.Globalization;

namespace Dienstfahrten.ControlTemplates.Dienstfahrten
{
    public partial class DienstfahrtenListeUserControl : UserControl
    {
        SPWeb currentWeb;
        Log log;

        List<HtmlGenericControl> listMenuDivs;
        public string SPversionPath = helper.getSharePointVersionPath();


        protected void Page_Load(object sender, EventArgs e)
        {
            currentWeb = SPContext.Current.Web;
            log = new Log();

            init();

            //Wenn noch kein Zeitraum ausgewählt wurde
            if (DienstfahrtenListeSeiteDiv.Visible && !Page.IsPostBack)
            {
                loadData(currentWeb);
            }

            if (!Page.IsPostBack)
            {
            }
        }


        public void loadData(SPWeb currentWeb)
        {
            //Fix für das Layout beim DateTimeControl. Tritt bei Managed Path auf ( http://stackoverflow.com/questions/4243408/sharepoint-2010-datetimecontrol-styling-issues )
            //inputDatumStart.DatePickerFrameUrl = currentWeb.ServerRelativeUrl + "/_layouts/iframe.aspx";
            //inputDatumEnde.DatePickerFrameUrl = currentWeb.ServerRelativeUrl + "/_layouts/iframe.aspx";                            

            //Dienstfahrten Übersicht
            DienstfahrtListe dl = new DienstfahrtListe(currentWeb);
            List<Object> dl_am = new List<object>();
            btnVerschicken.Enabled = true;
            if (hiddenZeitspanne.Value == string.Empty)
            {
                dl_am = dl.getListbyMonat(DateTime.Now.Month, DateTime.Now.Year, false, false, null);
                grdDienstfahrtListe.DataSource = dl_am;
                grdDienstfahrtListe.DataBind();
                menuUserControl.setMenuAktiv(amDiv, listMenuDivs);

                lblSummierteStrecke.Text = helper.berechneSummeDienstfahrtenKM(dl_am);
                if (dl_am.Count == 0) btnVerschicken.Enabled = false;
            }
            else
                DienstfahrtListeAuswahl_click(this, null);

            //Konfiguration
            Konfiguration konf = new Konfiguration(currentWeb);
            konf.getByUser(currentWeb.CurrentUser);

            if (konf.Empfaenger != null)
                btnVerschicken.Text = helper.GetLocalizedString("dl_SendeDaten") + " " + konf.Empfaenger.Name;
            //btnVerschicken.Text = DfMultiLanguabe.GetString("dl_SendeDaten") + " " + konf.Empfaenger.Name;
            else btnVerschicken.Text = helper.GetLocalizedString("dl_keinEmpfaenger");
        }

        /// <summary>
        /// Initialisiere Sichtbarkeint der Info/Fehler-Ausgaben
        /// </summary>
        private void init()
        {
            listMenuDivs = new List<HtmlGenericControl>();
            listMenuDivs.Add(ajDiv);
            listMenuDivs.Add(aqDiv);
            listMenuDivs.Add(q1Div);
            listMenuDivs.Add(q2Div);
            listMenuDivs.Add(q3Div);
            listMenuDivs.Add(q4Div);
            listMenuDivs.Add(hj1Div);
            listMenuDivs.Add(hj2Div);
            listMenuDivs.Add(q4vjDiv);
            listMenuDivs.Add(vjDiv);
            listMenuDivs.Add(q1njDiv);
            listMenuDivs.Add(njDiv);

            listMenuDivs.Add(amDiv);
            listMenuDivs.Add(janDiv);
            listMenuDivs.Add(febDiv);
            listMenuDivs.Add(mrzDiv);
            listMenuDivs.Add(aprDiv);
            listMenuDivs.Add(maiDiv);
            listMenuDivs.Add(junDiv);
            listMenuDivs.Add(julDiv);
            listMenuDivs.Add(augDiv);
            listMenuDivs.Add(sepDiv);
            listMenuDivs.Add(oktDiv);
            listMenuDivs.Add(novDiv);
            listMenuDivs.Add(dezDiv);


            lblbtnVerschickenInfo.Visible = false;
            lblCustomZeitraumInfo.Visible = false;
            inputDatumStart.SelectedDate = DateTime.MinValue;
            inputDatumEnde.SelectedDate = DateTime.MinValue;
        }


        /// <summary>
        /// Ausgewählte Daten verschicken.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnVerschicken_click(object sender, EventArgs e)
        {
            Konfiguration konf = new Konfiguration(currentWeb);
            Konfiguration test = (Konfiguration)konf.getByUser(currentWeb.CurrentUser);

            string zeit = hiddenZeitspanne.Value;
            DienstfahrtListe dl = new DienstfahrtListe(currentWeb);
            List<Object> dienstfahrten = new List<Object>();
            switch (zeit)
            {
                case "aj":
                    dienstfahrten = dl.getListbyAktuellesJahr(false, false, null);
                    break;
                case "aq":
                    dienstfahrten = dl.getListbyAktuellesQuartal(false, false, null);
                    break;
                case "q1":
                    dienstfahrten = dl.getListbyQuartal1(false, false, null);
                    break;
                case "q2":
                    dienstfahrten = dl.getListbyQuartal2(false, false, null);
                    break;
                case "q3":
                    dienstfahrten = dl.getListbyQuartal3(false, false, null);
                    break;
                case "q4":
                    dienstfahrten = dl.getListbyQuartal4(false, false, null);
                    break;
                case "hj1":
                    dienstfahrten = dl.getListbyHalbjahr1(false, false, null);
                    break;
                case "hj2":
                    dienstfahrten = dl.getListbyHalbjahr2(false, false, null);
                    break;
                case "q4vj":
                    dienstfahrten = dl.getListbyQuartal4Vorjahr(false, false, null);
                    break;
                case "vj":
                    dienstfahrten = dl.getListbyVorjahr(false, false, null);
                    break;
                case "q1nj":
                    dienstfahrten = dl.getListbyQuartal1Folgejahr(false, false, null);
                    break;
                case "nj":
                    dienstfahrten = dl.getListbyFolgejahr(false, false, null);
                    break;
                case "am":
                    dienstfahrten = dl.getListbyMonat(DateTime.Now.Month, DateTime.Now.Year, false, false, null);
                    break;
                case "jan":
                    dienstfahrten = dl.getListbyMonat(1, DateTime.Now.Year, false, false, null);
                    break;
                case "feb":
                    dienstfahrten = dl.getListbyMonat(2, DateTime.Now.Year, false, false, null);
                    break;
                case "mrz":
                    dienstfahrten = dl.getListbyMonat(3, DateTime.Now.Year, false, false, null);
                    break;
                case "apr":
                    dienstfahrten = dl.getListbyMonat(4, DateTime.Now.Year, false, false, null);
                    break;
                case "mai":
                    dienstfahrten = dl.getListbyMonat(5, DateTime.Now.Year, false, false, null);
                    break;
                case "jun":
                    dienstfahrten = dl.getListbyMonat(6, DateTime.Now.Year, false, false, null);
                    break;
                case "jul":
                    dienstfahrten = dl.getListbyMonat(7, DateTime.Now.Year, false, false, null);
                    break;
                case "aug":
                    dienstfahrten = dl.getListbyMonat(8, DateTime.Now.Year, false, false, null);
                    break;
                case "sep":
                    dienstfahrten = dl.getListbyMonat(9, DateTime.Now.Year, false, false, null);
                    break;
                case "okt":
                    dienstfahrten = dl.getListbyMonat(10, DateTime.Now.Year, false, false, null);
                    break;
                case "nov":
                    dienstfahrten = dl.getListbyMonat(11, DateTime.Now.Year, false, false, null);
                    break;
                case "dez":
                    dienstfahrten = dl.getListbyMonat(12, DateTime.Now.Year, false, false, null);
                    break;
                case "custom":
                    DateTime start = DateTime.MinValue;
                    DateTime ende = DateTime.MinValue;

                    if (validiereCustomZeitraum())
                    {
                        start = inputDatumStart.SelectedDate;
                        ende = inputDatumEnde.SelectedDate;
                    }
                    else
                    {
                        dl = null;
                        break;
                    }
                    dienstfahrten = dl.getListByDatum(start, ende, false, false, null);
                    break;
                default:
                    dl = null;
                    break;
            }
            
            bool result = false;
            if (test != null && dl != null)
            {
                Mail mail = new Mail(currentWeb, test, dienstfahrten);
                result = mail.createAndSendMail();
            }
            else result = false;

            lblbtnVerschickenInfo.Visible = true;

            if (result)
            {
                foreach (Dienstfahrt item in dienstfahrten)
                {
                    item.saveVerschicktToList(item.ID);
                }
                lblbtnVerschickenInfo.Text = helper.GetLocalizedString("dl_DatenGesendetErfolg");
            }
            else
            {
                lblbtnVerschickenInfo.Text = helper.GetLocalizedString("dl_keinEmpfaenger");
            }

            loadData(currentWeb);
        }

        /// <summary>
        /// Checkbox Verschickt wird angeklickt
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void cbxVerschicktAuswahl_click(object sender, EventArgs e)
        {
            DienstfahrtListeAuswahl_click(this, null);
        }


        void Check_Clicked(Object sender, EventArgs e)
        {

            // Calculate the subtotal and display the result in currency format.
            // Include tax if the check box is selected.
            DienstfahrtListeAuswahl_click(this, null);

        }

        /// <summary>
        /// Ausgewählten Zeitraum anzeigen.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnCustomDienstfahrtListeAuswahl_click(object sender, EventArgs e)
        {
            DateTime start = DateTime.MinValue;
            DateTime ende = DateTime.MinValue;

            if (validiereCustomZeitraum())
            {
                start = inputDatumStart.SelectedDate;
                ende = inputDatumEnde.SelectedDate;
            }
            else return;

            bool versand = chbxVersand.Checked;
            DienstfahrtListe dl = new DienstfahrtListe(currentWeb);
            List<Object> dlAuswahl = dl.getListByDatum(start, ende, false, false, null);
            if (versand) dlAuswahl.AddRange(dl.getListByDatum(start, ende, false, true, null));

            grdDienstfahrtListe.DataSource = dlAuswahl;
            grdDienstfahrtListe.DataBind();
            hiddenZeitspanne.Value = "custom";
            lblSummierteStrecke.Text = helper.berechneSummeDienstfahrtenKM(dlAuswahl);                
        }

        private bool validiereCustomZeitraum()
        {
            //Validation            
            DateTime start = DateTime.MinValue;
            if (inputDatumStart.SelectedDate == null || inputDatumStart.SelectedDate == DateTime.MinValue)
            {
                lblCustomZeitraumInfo.Visible = true;
                lblCustomZeitraumInfo.Text = helper.GetLocalizedString("dl_ErrorZeitStart");
                return false;
            }
            else start = inputDatumStart.SelectedDate;

            DateTime ende = DateTime.MinValue;
            if (inputDatumEnde.SelectedDate == null || inputDatumEnde.SelectedDate == DateTime.MinValue)
            {
                lblCustomZeitraumInfo.Visible = true;
                lblCustomZeitraumInfo.Text = helper.GetLocalizedString("dl_ErrorZeitEnde");
                return false;
            }
            else ende = inputDatumEnde.SelectedDate;

            if (start >= ende)
            {
                lblCustomZeitraumInfo.Visible = true;
                lblCustomZeitraumInfo.Text = helper.GetLocalizedString("dl_ErrorZeitEnde");
                return false;
            }

            return true;
        }

        /// <summary>
        /// Listendaten auswählen
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void DienstfahrtListeAuswahl_click(object sender, CommandEventArgs e)
        {
            string liste = string.Empty;
            if((e == null || ( e != null && e.CommandArgument.ToString() == string.Empty)) && hiddenZeitspanne.Value != string.Empty)
                liste = hiddenZeitspanne.Value;
            else
                liste = e.CommandArgument.ToString();
                

            //if (e.CommandName == "DienstfahrtListeAuswahl" && liste != string.Empty)
            if (liste != string.Empty)
            {
                DienstfahrtListe dl = new DienstfahrtListe(currentWeb);
                bool versand = chbxVersand.Checked;
                List<Object> dlAuswahl = new List<object>();

                switch (liste)
                {
                    case "aj":
                        dlAuswahl = dl.getListbyAktuellesJahr(false, versand, null);
                        if(versand) dlAuswahl.AddRange(dl.getListbyAktuellesJahr(false, false, null));
                        menuUserControl.setMenuAktiv(ajDiv, listMenuDivs);
                        break;
                    case "aq":
                        dlAuswahl = dl.getListbyAktuellesQuartal(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyAktuellesQuartal(false, false, null));
                        menuUserControl.setMenuAktiv(aqDiv, listMenuDivs);
                        break;
                    case "q1":
                        dlAuswahl = dl.getListbyQuartal1(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyQuartal1(false, false, null));
                        menuUserControl.setMenuAktiv(q1Div, listMenuDivs);
                        break;
                    case "q2":
                        dlAuswahl = dl.getListbyQuartal2(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyQuartal2(false, false, null));
                        menuUserControl.setMenuAktiv(q2Div, listMenuDivs);
                        break;
                    case "q3":
                        dlAuswahl = dl.getListbyQuartal3(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyQuartal3(false, false, null));
                        menuUserControl.setMenuAktiv(q3Div, listMenuDivs);
                        break;
                    case "q4":
                        dlAuswahl = dl.getListbyQuartal4(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyQuartal4(false, false, null));
                        menuUserControl.setMenuAktiv(q4Div, listMenuDivs);
                        break;
                    case "hj1":
                        dlAuswahl = dl.getListbyHalbjahr1(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyHalbjahr1(false, false, null));
                        menuUserControl.setMenuAktiv(hj1Div, listMenuDivs);
                        break;
                    case "hj2":
                        dlAuswahl = dl.getListbyHalbjahr2(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyHalbjahr2(false, false, null));
                        menuUserControl.setMenuAktiv(hj2Div, listMenuDivs);
                        break;
                    case "q4vj":
                        dlAuswahl = dl.getListbyQuartal4Vorjahr(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyQuartal4Vorjahr(false, false, null));
                        menuUserControl.setMenuAktiv(q4vjDiv, listMenuDivs);
                        break;
                    case "vj":
                        dlAuswahl = dl.getListbyVorjahr(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyVorjahr(false, false, null));
                        menuUserControl.setMenuAktiv(vjDiv, listMenuDivs);
                        break;
                    case "q1nj":
                        dlAuswahl = dl.getListbyQuartal1Folgejahr(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyQuartal1Folgejahr(false, false, null));
                        menuUserControl.setMenuAktiv(q1njDiv, listMenuDivs);
                        break;
                    case "nj":
                        dlAuswahl = dl.getListbyFolgejahr(false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyFolgejahr(false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "am":
                        dlAuswahl = dl.getListbyMonat(DateTime.Now.Month, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(DateTime.Now.Month, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(amDiv, listMenuDivs);
                        break;
                    case "jan":
                        dlAuswahl = dl.getListbyMonat(1, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(1, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "feb":
                        dlAuswahl = dl.getListbyMonat(2, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(2, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "mrz":
                        dlAuswahl = dl.getListbyMonat(3, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(3, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "apr":
                        dlAuswahl = dl.getListbyMonat(4, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(4, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "mai":
                        dlAuswahl = dl.getListbyMonat(5, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(5, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "jun":
                        dlAuswahl = dl.getListbyMonat(6, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(6, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "jul":
                        dlAuswahl = dl.getListbyMonat(7, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(7, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "aug":
                        dlAuswahl = dl.getListbyMonat(8, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(8, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "sep":
                        dlAuswahl = dl.getListbyMonat(9, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(9, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "okt":
                        dlAuswahl = dl.getListbyMonat(10, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(10, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "nov":
                        dlAuswahl = dl.getListbyMonat(11, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(11, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "dez":
                        dlAuswahl = dl.getListbyMonat(12, DateTime.Now.Year, false, versand, null);
                        if (versand) dlAuswahl.AddRange(dl.getListbyMonat(12, DateTime.Now.Year, false, false, null));
                        menuUserControl.setMenuAktiv(njDiv, listMenuDivs);
                        break;
                    case "custom":
                        this.btnCustomDienstfahrtListeAuswahl_click(null, null);
                        return;
                        break;
                    default:
                        dlAuswahl = dl.getListbyAktuellesJahr(false, versand, null);
                        menuUserControl.setMenuAktiv(ajDiv, listMenuDivs);
                        break;
                }

                grdDienstfahrtListe.DataSource = dlAuswahl;
                grdDienstfahrtListe.DataBind();
                hiddenZeitspanne.Value = liste;
                lblSummierteStrecke.Text = helper.berechneSummeDienstfahrtenKM(dlAuswahl);

                //Deaktiviere Button wenn keine Elemente vorhanden sind
                if (dlAuswahl.Count == 0)
                    btnVerschicken.Enabled = false;
                else btnVerschicken.Enabled = true;
            }
        }


        /// <summary>
        /// Dienstfahrt löschen
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnDeleteDienstfahrt_click(object sender, CommandEventArgs e)
        {
            if (e.CommandName == "btnDeleteDienstfahrt" && e.CommandArgument.ToString() != string.Empty)
            {
                try
                {
                    int id = int.Parse(e.CommandArgument.ToString());
                    Dienstfahrt df = new Dienstfahrt(currentWeb);
                    df.deleteById(id);

                    loadData(currentWeb);
                }
                catch (Exception ex)
                {
                    log.Error(ex);
                }

            }
        }



        //##############################
        //Gridview Einstellungen
        //##############################
        protected void grdViewDienstfahrtListe_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            grdDienstfahrtListe.PageIndex = e.NewPageIndex;
        }

        protected void gridViewDienstfahrt_Sorting(object sender, GridViewSortEventArgs e)
        {
            string lastExpression = string.Empty;
            if (ViewState["SortExpression"] != null)
                lastExpression = ViewState["SortExpression"].ToString();

            SortDirection lastDirection = SortDirection.Ascending;
            if (ViewState["SortDirection"] != null)
                lastDirection = (SortDirection)ViewState["SortDirection"];

            SortDirection newDirection = SortDirection.Ascending;
            if (e.SortExpression == lastExpression)
                newDirection = (lastDirection == SortDirection.Ascending) ? SortDirection.Descending : SortDirection.Ascending;

            ViewState["SortExpression"] = e.SortExpression;
            ViewState["SortDirection"] = newDirection;
        }

        /// <summary>
        /// Set Dynamic ImageURL by Server
        /// </summary>
        /// <param name="e"></param>
        protected void TemplateUpdate_grdDienstfahrtListe(Object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                Image imgbtnVerschickt = (Image)e.Row.Cells[5].FindControl("imgVerschickt");
                if (imgbtnVerschickt != null)
                    imgbtnVerschickt.ImageUrl = "~/_layouts/" + SPversionPath + "images/Dienstfahrten/tick.png";

                Image imgbtnNichtVerschickt = (Image)e.Row.Cells[5].FindControl("imgNichtverschickt");
                if (imgbtnNichtVerschickt != null)
                    imgbtnNichtVerschickt.ImageUrl = "~/_layouts/" + SPversionPath + "images/Dienstfahrten/no-sign.png";

                ImageButton imgbtnDelDienstfahrt = (ImageButton)e.Row.Cells[6].FindControl("imgbtnDelDienstfahrt");
                if (imgbtnDelDienstfahrt != null)
                    imgbtnDelDienstfahrt.ImageUrl = "~/_layouts/" + SPversionPath + "images/Dienstfahrten/close-tab.png";
            }
        }


    }
}
